clear all;
format short eng;

%% Parameters

Prated=5*746;
p=4;
We_rated=60*2*pi;
Rs=0.423;
Ls=4.96e-3;
Lambda_f=0.422;
Wrm=800*2*pi/60;
Te=10;

%% CH2 11.1

We=Wrm*p/2;
sprintf('(1) The angular frequency of the stator voltage is %frad/sec',We)

%% CH2 11.2

Is=Te*2/p/3/Lambda_f;
Ei=Lambda_f*We;
Vs=Ei+Rs*Is+j*Ls*We*Is;
sprintf('(2) The line-to-line voltage is %fVrms and the line current is %fArms',sqrt(3)*abs(Vs),Is)

%% CH2 11.3

pf=cos(angle(Is)-angle(Vs));
sprintf('(3) The power factor at the terminal of the machine is %f',pf)

%% CH2 11.4

Delta=angle(Is)-angle(Vs);
sprintf('(4) The load angle is %fdegrees',Delta*180/pi)