%% parameters and Conditions
clear all;
clc;

Pm_rate=110e3;
Ra=0.025;
% Ra=0.1027;
La=1.557e-3;
Ia_rate=274;
Wrm_rate=560*2*pi/60;
Va_rate=440;
Lf=10.77;
Rf=13.58;
If_rate=14.4;
J=11.5;
Weight=2000;


Va=220;
Vf=196;
%Vf=220;
T_L=1800;
Jeq=2*J;

%% find k parameter
Ke=(Va_rate-Ia_rate*Ra)/(Lf*If_rate*Wrm_rate);
Kt=Pm_rate/Wrm_rate/(Lf*If_rate*Ia_rate);
K=(Ke+Kt)/2;
%% operation condition in steady state 
If=Vf/Rf;
Ia=T_L/(K*Lf*If);
Wrm=(Va-Ia*Ra)/(K*Lf*If);
Wrm_rpm=Wrm*60/(2*pi);
%% small signal analysis transfer fucntion
s=tf('s');
dWrm_dVf=K*Lf/(Rf+s*Lf)*((Ia-(K*Lf*If)/(Ra+s*La)*Wrm)/(s*Jeq+(K*Lf*If)^2/(Ra+s*La)));
dWrm_dVf=K*Lf/(Rf+s*Lf)*(Ia*(Ra+s*La)-K*Lf*If*Wrm)/(s*Jeq*(Ra+La*s)+(K*If*Lf)^2)
% pole_dWrm_dVf=pole(dWrm_dVf)
% zero_dWrm_dVf=zero(dWrm_dVf)

%n=[0.0003023, -0.1577, -2.562];
%d=[0.0006005, 0.02004, 1.032, 14.97, 17.27];

n=[0.1942, -102.5];
d=[0.3857, 6.679, 555.4, 690.8];
%%

sim('Respose_of_dWrm_dVf.mdl',10);
figure(1);
plot(time, Wrm_rpm_2,'r',time,Wrm_rpm_3,'--b','LineWidth',2); grid on; xlabel('time[sec]');ylabel('Wrm[rpm]');legend('2-(2)_Wrm','2-(3)_Wrm')
%%

figure(1);
subplot(2,1,1);plot(t,Te_ref,'r',t,Te,'--b','LineWidth',2); grid on; xlabel('time[sec]');ylabel('Torque[N-m]');legend('Te_{ref}','Te')
subplot(2,1,2);plot(t,Wrpm,'LineWidth',2); grid on; xlabel('time[sec]');ylabel('Speed[r/min]');legend('Wrpm')
figure(2);
subplot(2,1,1);plot(t,Idqse_ref(:,1),'r',t,Idqse(:,1),'--b','LineWidth',2); grid on;xlabel('time[sec]');ylabel('Current[A]');legend('I_{ds}^{e}ref','I_{de}^{r}');
subplot(2,1,2);plot(t,Idqse_ref(:,2),'r',t,Idqse(:,2),'--b','LineWidth',2); grid on;xlabel('time[sec]');ylabel('Current[A]');legend('I_{qs}^{e}ref','I_{qe}^{r}');
figure(3);
plot(t,LAMdre_ref,'r',t,LAMdqr(:,1),'--b',t,LAMdqr(:,2),'k','LineWidth',2); grid on;xlabel('time[sec]');ylabel('Current[A]');legend('LAM_{dr}^{e}ref','LAM_{dr}^{e}','LAM_{qr}^{e}');
figure(4);
plot(t,Theta_error);grid on;



%%


