clear all
%%
%־ 
R_a=6.28;
L_a=53.6*10^-3;
L_f=221;
R_f=858;
P=2*1000;


I_a=5.7;
W_rm=2243*2*pi/60;
T_e=P/W_rm;
I_f=0.225;
J_M=0.0224;
V_a=440;

%%
%K Average

K1=(V_a-I_a*R_a)/(I_f*W_rm);
K2=(T_e)/(I_f*I_a);
K=(K1+K2)/2;

Ki=K;

e_g=-V_a-I_a*R_a;
% e_g2=(-P/I_a-I_a*R_a);

%%
%Boundary value of angular speed
%Constant torque
W_rm=(V_a-I_a*R_a)/(Ki*I_f); %1 Quadrant
W_rmg=(e_g)/(Ki*I_f); %2 Quadrant

%Field weakening region
W3=(V_a-I_a*R_a)/(Ki*1/3*I_f);%1 Quadrant; 1/3I_f 
W3g=(e_g)/(Ki*1/3*I_f);%2 Quadrant

%% w for plot
w1=[-1000:0.1:1000];


range1=find(w1>W3g);%=>          0          
range1=range1(1);

range2=find(w1<W3);%          0          <=
k=size(range2);
range2=range2(k(2));

w=[w1(range1):0.1:w1(range2)];% range for plot


%% 
%
v_a=zeros(size(w));
i_f=zeros(size(w));

A=size(w);

for j=A(1):A(2)
    if (W3g<w(j) && w(j)<W_rmg)
        V_p=V_a;
        i_f(j)=(-V_p-I_a*R_a)/(Ki*w(j));
        v_a(j)=-V_p;
        
    elseif ((W_rmg<w(j))&&(w(j)<W_rm) )
        i_f(j)=I_f;
        v_a(j)=I_a*R_a+Ki*I_f*w(j);
        
    elseif ((W_rm<w(j))&&(w(j)<W3))
        i_f(j)=(V_a-I_a*R_a)/(Ki*w(j));
        v_a(j)=V_a;
        
    elseif(w(j)>W3)
        i_f(j)=I_f/3;
        v_a(j)=V_a;
        
    elseif(w(j)<W3g)
        i_f(j)=I_f/3;
        V_p=V_a;
        v_a(j)=-V_p;
        
    end
    
end
%%  
%
for i=A(1):A(2)
    t_e(i)=Ki*i_f(i)*I_a;
   
    if(w(i)>0)
        p(i)=t_e(i)*w(i);
    else
        p(i)=v_a(i)*I_a;
    end
   
    pm(i)=t_e(i)*w(i);
    pe(i)=v_a(i)*I_a;
    
    
end
%%

    
    
w2=w*60/(2*pi);
    
figure;hold on
plot(w2, v_a/100, 'r',w2,i_f*50,'m',w2,t_e,'b',w2,pm/500, 'b','LineWidth',1);xlabel('Wrm[rpm]');legend('Va/100[V]','if*50', 'Te','Pm/500')



grid






