%%
clear all;
clc;
%% (1)
Pm=2250*746;
Va_rms=2300/sqrt(3);
Va=Va_rms*sqrt(2);
We=2*pi*60;
Wrm=1786*2*pi/60;
pole=4;
Wr=Wrm*pole/2
Rs=0.029;
Rr=0.022;
Xls=0.226;
Xlr=0.226;
Xm=13.04;
Slip=(We-Wr)/We;
Zm=j*Xm;
Zr=Rr/Slip+j*Xlr;
Zeq=Zm*Zr/(Zm+Zr);
Zs=Rs+j*Xls;
Ztotal=Zs+Zeq;
Em=Va*Zeq/Ztotal;
Is=Va/Ztotal;
Is_abs=abs(Is);
Ir_abs=abs(Em/Zr);
%% (2)
Lls=Xls/(We);
Llr=Xlr/(We);
Lm=Xm/(We);
Lk=Lls+Lm*Llr/(Lm+Llr);
Esmag=(Lm/(Lm+Llr)*Ir_abs*Rr/Slip);
Es_l2l=Esmag*sqrt(3);
Xk=We*Lk;
Es=Va-(Rs+j*Xk)*Is;% Back EMF voltage when phase of source voltage is zero;mreans only real component.
% Cut-off of power when Is is zero crossing from negative to positive.
% Set the phase of Is as zero when power is cut-off.
Angle_adj=-angle(Is)+angle(Es);
%Es_cutoff=Esmag*sin(We*t+Angle_adj); Back emf voltage when cut off after
%phase adjustment.
%Vab=Esmag*sqrt(3)*Esmag*sin(We*t+Angle_adj+pi/6)


%% (3)
% Source voltage at the disconnection
% Vas=Va*sin(We*t-angle(Is))
%At t=375ms,Source Voltage phase is We*.375-angle(Is)-n*2*pi
%At t=375ms,Back EMF Voltage phase is Wr*.375-angle(Is)+angle(Es)-n*2*pi
% Stator current after reconnection
Ia_recon=(Va*(cos(We*.375-angle(Is))+j*sin(We*.375-angle(Is)))-Esmag*(cos(Wr*.375+Angle_adj)+j*sin(We*.375+Angle_adj)))/j/Xk;
Ia_mag=abs(Ia_recon);
Ia_angle=angle(Ia_recon);
%%
