clear all;
format short eng;

%% Parameter
P_rate=22000;
Rs=0.044;
Rr=0.0252;
Lls=0.00055;
Llr=0.00047;
Lm=0.0129;
P=4;
Vline_rate=220;
Vs_rate=220/sqrt(3);
Hz_rate=60;
We_rate=Hz_rate*pi*2;
Wrm_rate=1755*2*pi/60;
Wr_rate=Wrm_rate/(2/P);

Wsl_rate=We_rate-Wr_rate;
slip_rate=Wsl_rate/We_rate;

Zs=j*Lls*We_rate+Rs;
Zr=Rr/slip_rate+j*Llr*We_rate;
Zm=j*Lm*We_rate;
Ztotal=Zs+1/(1/Zr+1/Zm);

Is_rate=75;
Is_rate_magnitude=abs(Is_rate);
%angle(Is_rate)*180/pi()
Em_rate=Vs_rate-Zs*Is_rate;
%abs(Em_rate)
%angle(Em_rate)*180/pi()

%% Problem 2-14 (1)
% When the frequency changes from 5Hz to 170Hz in 15Hz intervals, plot the
% steadystate torque-speed curves of the machine at each frequency in the
% torque speed plan.

V_by_F_rate_1=Vs_rate/Hz_rate;
Hz_step=1;
Hz_start=1;
Hz_finish=170;
Hz_test_num=(Hz_finish-Hz_start)/Hz_step+1; %step number from 5Hz to 170Hz
slip_step_size=10000;% you can inclrease this value to find more detail point.

Wrm_rpm=zeros(1,Hz_test_num);% to get the value from 0
Torque=zeros(1,Hz_test_num);
Hz=zeros(1,Hz_test_num);
We=zeros(1,Hz_test_num);
Em=zeros(1,Hz_test_num);
Vs=zeros(1,Hz_test_num);
Is=zeros(slip_step_size,Hz_test_num);
Ir_magnitude=zeros(1,Hz_test_num);
Ir_magnitude2=zeros(1,Hz_test_num);
Zs=zeros(1,Hz_test_num);
Zm=zeros(1,Hz_test_num);
Zr=zeros(slip_step_size+1,Hz_test_num);
Zr_choosen=zeros(1,Hz_test_num);
Is_magnitude=zeros(slip_step_size+1,Hz_test_num);
Is_magnitude_serch=zeros(slip_step_size+1,1);
Is_magnitude_choosen=zeros(1,Hz_test_num);
slip=zeros(slip_step_size+1,Hz_test_num);
slip_choosen=zeros(1,Hz_test_num+1);
Point_rate=floor((Hz_rate-Hz_start)/Hz_step)+1;


for k=1:(Hz_test_num)
    if(k<=Point_rate)
        Hz(k)=(k-1)/(Hz_test_num-1)*(Hz_finish-Hz_start)+Hz_start;
        We(k)=Hz(k)*2*pi;
        Vs(k)=V_by_F_rate_1*Hz(k);
        Zs(k)=Rs+1i*Lls*We(k);
        Zm(k)=1i*Lm*We(k);
        for p=1:slip_step_size+1
            slip(p,k)=1/slip_step_size*(p-1);
            Zr(p,k)=1i*We(k)*Llr+Rr/slip(p,k);
            Is_magnitude(p,k)=abs(Vs(k)/(Zs(k)+1/((1/Zm(k))+1/(Zr(p,k)))));
            Is_magnitude_serch(p)=abs(Vs(k)/(Zs(k)+1/((1/Zm(k))+1/(Zr(p,k)))));
        end
          slip_choosen(k)=slip(max(find(Is_magnitude_serch<Is_rate_magnitude)),k);
          Is_magnitude_choosen(k)=Is_magnitude(max(find(Is_magnitude_serch<Is_rate_magnitude)),k);
          Zr_choosen(k)=1i*We(k)*Llr+Rr/slip_choosen(k);
          Ir_magnitude(k)=abs(Is_magnitude_choosen(k)*(Zm(k)/(Zm(k)+Zr_choosen(k))));
          Wrm_rpm(k)=(1-slip_choosen(k))*We(k)*60/2/pi*2/P;
          Torque(k)=3*P/2*(Rr/slip_choosen(k))*Ir_magnitude(k)^2/We(k);
         
         
         
    else
        Hz(k)=(k-1)/(Hz_test_num-1)*(Hz_finish-Hz_start)+Hz_start;
        We(k)=Hz(k)*2*pi;
        Vs(k)=Vs_rate;
        Zs(k)=Rs+1i*Lls*We(k);
        Zm(k)=1i*Lm*We(k);
        for p=1:slip_step_size+1
           slip(p,k)=1/slip_step_size*(p-1);
           Zr(p,k)=1i*We(k)*Llr+Rr/slip(p,k);
           Is_magnitude(p,k)=abs(Vs(k)/(Zs(k)+1/((1/Zm(k))+1/(Zr(p,k)))));
           Is_magnitude_serch(p)=abs(Vs(k)/(Zs(k)+1/((1/Zm(k))+1/(Zr(p,k)))));
           
        end
        slip_choosen(k)=slip(max(find(Is_magnitude_serch<Is_rate_magnitude)),k);
        Zr_choosen(k)=1i*We(k)*Llr+Rr/slip_choosen(k);
        Is_magnitude_choosen(k)=Is_magnitude(max(find(Is_magnitude_serch<Is_rate_magnitude)),k);
        Ir_magnitude(k)=abs(Is_magnitude_choosen(k)*(Zm(k)/(Zm(k)+Zr_choosen(k))));
        Wrm_rpm(k)=(1-slip_choosen(k))*We(k)*60/2/pi*2/P;
        Torque(k)=3*P/2*(Rr/slip_choosen(k))*Ir_magnitude(k)^2/We(k);
    end
    
end

figure(1);
plot(Wrm_rpm,Torque,'b');
grid on;
title('Ex2-14 (1)Torque-Speed curve of 22kW induction machine by V/F operation');
xlabel('Wrm[rpm]');
ylabel('Te[N-m]');

%% Problem 2-14 (2)
% Repeat part 1 when the ratio of the air-gap voltage in phase rms to the
% frequency of the machine is kept as 111/60 up to 60Hz, and above 60Hz the
% air gap voltage is constant at 111V in phase voltage rms.

V_by_F_rate_1=Vs_rate/Hz_rate;
Hz_step=1;
Hz_start=1;
Hz_finish=170;
Hz_test_num=(Hz_finish-Hz_start)/Hz_step+1; %step number from 5Hz to 170Hz
slip_step_size=10000;% you can inclrease this value to find more detail point.
Em_rate=111;
V_by_F_rate_2=Em_rate/Hz_rate;

Wrm_rpm=zeros(1,Hz_test_num);% to get the value from 0
Torque=zeros(1,Hz_test_num);
Hz=zeros(1,Hz_test_num);
We=zeros(1,Hz_test_num);
Em=zeros(1,Hz_test_num);
Vs2=zeros(1,Hz_test_num);
Ir_magnitude=zeros(1,Hz_test_num);
Is=zeros(slip_step_size,Hz_test_num);
Zs=zeros(1,Hz_test_num);
Zm=zeros(1,Hz_test_num);
Zr=zeros(slip_step_size+1,Hz_test_num);
Zr_choosen=zeros(1,Hz_test_num);
Is_magnitude=zeros(slip_step_size+1,Hz_test_num);
Is_magnitude_serch=zeros(slip_step_size+1,1);
Is_magnitude_choosen=zeros(1,Hz_test_num);
slip=zeros(slip_step_size+1,Hz_test_num);
slip_choosen=zeros(1,Hz_test_num+1);
Point_rate=floor((Hz_rate-Hz_start)/Hz_step)+1;

for k=1:(Hz_test_num)
    if(k<=Point_rate)
        Hz(k)=(k-1)/(Hz_test_num-1)*(Hz_finish-Hz_start)+Hz_start;
        We(k)=Hz(k)*2*pi;
        Em(k)=V_by_F_rate_2*Hz(k);
        Zs(k)=Rs+1i*Lls*We(k);
        Zm(k)=1i*Lm*We(k);
        for p=1:slip_step_size+1
           slip(p)=1/slip_step_size*(p-1);
           Zr(p,k)=1i*We(k)*Llr+Rr/slip(p);
           Is_magnitude(p,k)=abs(Em(k)/(1/((1/Zm(k))+1/(Zr(p,k)))));
           Is_magnitude_serch(p)=abs(Em(k)/(1/((1/Zm(k))+1/(Zr(p,k)))));
        end
        slip_choosen(k)=slip((max(find(Is_magnitude_serch<Is_rate_magnitude))));
        Is_magnitude_choosen(k)=Is_magnitude(max(find(Is_magnitude_serch<Is_rate_magnitude)),k);
        Zr_choosen(k)=1i*We(k)*Llr+Rr/slip_choosen(k);
        Vs2(k)=abs(Em(k)+Zs(k)*Is_magnitude_choosen(k));
        Ir_magnitude(k)=abs(Is_magnitude_choosen(k)*(Zm(k)/(Zm(k)+Zr_choosen(k))));
        Wrm_rpm(k)=(1-slip_choosen(k))*We(k)*60/2/pi*2/P;
        Torque(k)=3*P/2*(Rr/slip_choosen(k))*Ir_magnitude(k)^2/We(k);
    else
        Hz(k)=(k-1)/(Hz_test_num-1)*(Hz_finish-Hz_start)+Hz_start;
        We(k)=Hz(k)*2*pi;
        Em(k)=Em_rate;
        Zs(k)=Rs+1i*Lls*We(k);
        Zm(k)=1i*Lm*We(k);
        for p=1:slip_step_size+1
           slip(p)=1/slip_step_size*(p-1);
           Zr(p,k)=1i*We(k)*Llr+Rr/slip(p);
           Is_magnitude(p,k)=abs(Em(k)/(1/((1/Zm(k))+1/(Zr(p,k)))));
           Is_magnitude_serch(p)=abs(Em(k)/(1/((1/Zm(k))+1/(Zr(p,k)))));
           
        end
        slip_choosen(k)=slip(max(find(Is_magnitude_serch<Is_rate_magnitude)));
        Is_magnitude_choosen(k)=Is_magnitude(max(find(Is_magnitude_serch<Is_rate_magnitude)),k);
        Zr_choosen(k)=1i*We(k)*Llr+Rr/slip_choosen(k);
        Vs2(k)=abs(Em(k)+Zs(k)*Is_magnitude_choosen(k));
        Ir_magnitude(k)=abs(Is_magnitude_choosen(k)*(Zm(k)/(Zm(k)+Zr_choosen(k))));
        Wrm_rpm(k)=(1-slip_choosen(k))*We(k)*60/2/pi*2/P;
        Torque(k)=3*P/2*(Rr/slip_choosen(k))*Ir_magnitude(k)^2/We(k);
    end
    
end

figure(2);
plot(Wrm_rpm,Torque,'b');
grid on;
ylim([20 140]);
xlim([1 5100]);
title('Ex2-14 (2)Torque-Speed curve of 22kW induction machine by V/F operation');
xlabel('Wrm[rpm]');
ylabel('Te[N-m]');

%% Problem 2-14 (3)
%Plot the capability curve of the induction machine operating according to
%the conditions in part 2 at the first quadrant of the torque-speed plane.

Hz_step=1;
Hz_start=1;
Hz_finish=210;
Hz_test_num=(Hz_finish-Hz_start)/Hz_step+1; %step number from 5Hz to 170Hz

Wrm_rpm=zeros(1,Hz_test_num);% to get the value from 0
Torque=zeros(1,Hz_test_num);
Hz=zeros(1,Hz_test_num);
We=zeros(1,Hz_test_num);
Em=zeros(1,Hz_test_num);
Vs2=zeros(1,Hz_test_num);
Ir_magnitude=zeros(1,Hz_test_num);
Is=zeros(slip_step_size,Hz_test_num);
Zs=zeros(1,Hz_test_num);
Zm=zeros(1,Hz_test_num);
Zr=zeros(slip_step_size+1,Hz_test_num);
Zr_choosen=zeros(1,Hz_test_num);
Is_magnitude=zeros(slip_step_size+1,Hz_test_num);
Is_magnitude_serch=zeros(slip_step_size+1,1);
Is_magnitude_choosen=zeros(1,Hz_test_num);
slip=zeros(slip_step_size+1,Hz_test_num);
slip_choosen=zeros(1,Hz_test_num+1);
Point_rate=floor((Hz_rate-Hz_start)/Hz_step)+1;

for k=1:(Hz_test_num)
    if(k<=Point_rate)
        Hz(k)=(k-1)/(Hz_test_num-1)*(Hz_finish-Hz_start)+Hz_start;
        We(k)=Hz(k)*2*pi;
        Em(k)=V_by_F_rate_2*Hz(k);
        Zs(k)=Rs+1i*Lls*We(k);
        Zm(k)=1i*Lm*We(k);
        for p=1:slip_step_size+1
           slip(p)=1/slip_step_size*(p-1);
           Zr(p,k)=1i*We(k)*Llr+Rr/slip(p);
           Is_magnitude(p,k)=abs(Em(k)/(1/((1/Zm(k))+1/(Zr(p,k)))));
           Is_magnitude_serch(p)=abs(Em(k)/(1/((1/Zm(k))+1/(Zr(p,k)))));
        end
        slip_choosen(k)=slip((max(find(Is_magnitude_serch<Is_rate_magnitude))));
        Is_magnitude_choosen(k)=Is_magnitude(max(find(Is_magnitude_serch<Is_rate_magnitude)),k);
        Zr_choosen(k)=1i*We(k)*Llr+Rr/slip_choosen(k);
        Vs2(k)=abs(Em(k)+Zs(k)*Is_magnitude_choosen(k));
        Ir_magnitude(k)=abs(Is_magnitude_choosen(k)*(Zm(k)/(Zm(k)+Zr_choosen(k))));
        Wrm_rpm(k)=(1-slip_choosen(k))*We(k)*60/2/pi*2/P;
        Torque(k)=3*P/2*(Rr/slip_choosen(k))*Ir_magnitude(k)^2/We(k);
    else
        Hz(k)=(k-1)/(Hz_test_num-1)*(Hz_finish-Hz_start)+Hz_start;
        We(k)=Hz(k)*2*pi;
        Em(k)=Em_rate;
        Zs(k)=Rs+1i*Lls*We(k);
        Zm(k)=1i*Lm*We(k);
        for p=1:slip_step_size+1
           slip(p)=1/slip_step_size*(p-1);
           Zr(p,k)=1i*We(k)*Llr+Rr/slip(p);
           Is_magnitude(p,k)=abs(Em(k)/(1/((1/Zm(k))+1/(Zr(p,k)))));
           Is_magnitude_serch(p)=abs(Em(k)/(1/((1/Zm(k))+1/(Zr(p,k)))));
           
        end
        slip_choosen(k)=slip(max(find(Is_magnitude_serch<Is_rate_magnitude)));
        Is_magnitude_choosen(k)=Is_magnitude(max(find(Is_magnitude_serch<Is_rate_magnitude)),k);
        Zr_choosen(k)=1i*We(k)*Llr+Rr/slip_choosen(k);
        Vs2(k)=abs(Em(k)+Zs(k)*Is_magnitude_choosen(k));
        Ir_magnitude(k)=abs(Is_magnitude_choosen(k)*(Zm(k)/(Zm(k)+Zr_choosen(k))));
        Wrm_rpm(k)=(1-slip_choosen(k))*We(k)*60/2/pi*2/P;
        Torque(k)=3*P/2*(Rr/slip_choosen(k))*Ir_magnitude(k)^2/We(k);
    end
    
end

figure(3);
plot(Wrm_rpm,Torque,'b','linewidth',3/2);
grid on;
hold on;
plot(Wrm_rpm,Is_magnitude_choosen,'r','linewidth',3/2);
plot(Wrm_rpm,Em,'k','linewidth',3/2);
plot(Wrm_rpm,Vs2,'r');
plot(Wrm_rpm,Vs_rate,'r');
title('Ex2-14 (3)Capability curve of 22kW induction machine by V/F operation');
xlabel('Wrm[rpm]');
ylabel('Te[N-m]');
legend('Torque','Is','Em','Vs',15);
xlim([0 6000]);

hold off;
