clear all;
format short eng;
%% Problem 2-15 
%plot the capagility curve of the induction machine, whose parameters and
%limiting conditions are listed belows, in the format shown in Fig 2.77.

%% Parameter

P_rate=185000;
Rs=0.014;
Rr=0.014;
P=4;
We_rate=60*2*pi;
Wr_rate=1773*2*pi/60*P/2;
Vs_rate=440/sqrt(3);
Lls=0.278e-3;
Llr=0.278e-3;
Lm=15e-3;

%% Rated condition

%% 2-15 (1)
% Calculate Wsl1, Where the rated torque occurs at the rated stator voltage
% and frequency, in electrical ansgular frequency, [rad/s]
Wsl_rate=We_rate-Wr_rate;
Answer_1_Wsl_rate=Wsl_rate;
slip_rate=Wsl_rate/We_rate;


%% (2)
% Calculate the magnitude of line to line voltage in rms, Vo, where the
% rated torque occurs at zero running speed, which is a stalled condition
We0=Wsl_rate;
Te=P_rate/Wr_rate*P/2;
Ir0=sqrt(2*Te*We0/(3*P*Rr));
Em0=abs(Ir0*sqrt((Rr)^2+(We0*Llr)^2));
Zmr0=abs(1/(1/(i*We0*Lm)+(1/(i*We0*Llr+Rr))));
Zeq0=abs(Rs+i*We0*Lls+1/(1/(i*We0*Lm)+(1/(i*We0*Llr+Rr))));
Vs0=Em0*Zeq0/Zmr0;
Vline0=sqrt(3)*Vs0;


%% (3)
% Calculate the magnitude of the stator current in rms, Is, where the rated
% torque occurs at the rated stator voltage and frequency
Zs=j*Lls*We_rate+Rs;
Zr=Rr/slip_rate+j*Llr*We_rate;
Zm=j*Lm*We_rate;
Zeq=Zs+1/(1/Zr+1/Zm);
Is_rate=Vs_rate/Zeq;
Is_rate_mag=abs(Is_rate);
Em_rate=Is_rate*1/((1/Zr)+(1/Zm));
lamda_rate=abs(Em_rate/We_rate);

%% (4)
% Calculate rated torque
Te=P_rate/Wr_rate*P/2;

%% (5)
% Calculate wsl_pk, where pull out torque occurs
Wsl_pk=Rr/Llr;
%% (6)
% Calculate the angular frequency of the speed, where the flux weakning
% reagion 2 starts. In the calculation of Wsl_pk and W2 thre stator
% resistance Rs can be ndglected as 0

Zr_rate=abs(Rr/slip_rate+i*We_rate*Llr);
We2=sqrt((Zr_rate^2)/(2*Llr^2));

%% plot

Resol=1000; %е
Wmax=17000*2*pi/60*P/2;

% To find We1 point
Srated=round(Resol*We_rate/Wmax);
% To find We2 point
Wrm2_rpm=solve('0.9392^2=(0.014/50.3597*(x*pi/15+50.3597))^2+(0.000278*(50.3597+x*pi/15))^2')
Wrm2_rpm=11165.7446;
We2=Wsl_pk+Wrm2_rpm*2*pi/60*P/2;
S2=round(Resol*We2/Wmax);

We=zeros(1,Resol);
Wrm=zeros(1,Resol);
Wsl=zeros(1,Resol);
s=zeros(1,Resol);
Zs=zeros(1,Resol);
Zr=zeros(1,Resol);
Zm=zeros(1,Resol);
Is=zeros(1,Resol);
Ir=zeros(1,Resol);
T=zeros(1,Resol);
Em=zeros(1,Resol);
lamda=zeros(1,Resol);
Vs=zeros(1,Resol);
Pout=zeros(1,Resol);

for k=1:Resol
    
    if k<=Srated
        We(k)=(k)/(Srated)*(We_rate); 
        Wsl(k)=Wsl_rate;
        s(k)=Wsl(k)/We(k);
        Wrm(k)=(1-s(k))*We(k)*2/P*60/2/pi;
        Zs(k)=i*Lls*We(k)+Rs;
        Zr(k)=Rr/s(k)+Llr*We(k)*i;
        Zm(k)=Lm*We(k)*i;
        lamda(k)=lamda_rate;  %constant
        Em(k)=lamda(k)*We(k);
        Vs(k)=abs(Em(k)*(Zs(k)+(1/((1/Zr(k))+(1/Zm(k)))))/(1/((1/Zr(k))+(1/Zm(k)))));
        Is(k)=Vs(k)/(Zs(k)+(1/((1/Zr(k))+(1/Zm(k)))));
        Ir(k)=Is(k)*Zm(k)/(Zm(k)+Zr(k));
        T(k)=3/2*P*Rr*abs(Ir(k))^2/Wsl(k);
        Pout(k)=T(k)*(1-s(k))*We(k)*2/P;
        if k==Srated
           % W2=abs(Zr(Srated))/(sqrt(2)*Llr);%%ٽ
           % S2=round(Resol*W2/Wmax);%%ٽ
        end

    elseif k>Srated && k<=S2
        We(k)=We_rate+(k-Srated)*(We2-We_rate)/(S2-Srated);
        s(k)=Rr/sqrt(abs(Zr(Srated))^2-(Llr*We(k))^2);
        Wsl(k)=We(k)*s(k);
        Wrm(k)=(1-s(k))*We(k)*2/P*60/2/pi;
        Zs(k)=Lls*We(k)*i+Rs;
        Zr(k)=Rr/s(k)+Llr*We(k)*i;
        Zm(k)=Lm*We(k)*i;
        lamda(k)=lamda(Srated)*We(Srated)/We(k);
        Em(k)=lamda(k)*We(k); %constant
        Vs(k)=abs(Em(k)*(Zs(k)+(1/((1/Zr(k))+(1/Zm(k)))))/(1/((1/Zr(k))+(1/Zm(k)))));
        Is(k)=Vs(k)/(Zs(k)+(1/((1/Zr(k))+(1/Zm(k)))));
        Ir(k)=Is(k)*Zm/(Zm+Zr);
        T(k)=3/2*P*Rr*abs(Ir(k))^2/Wsl(k);
        Pout(k)=T(k)*(1-s(k))*We(k)*2/P;

    else
        We(k)=We2+(k-S2)/(Resol-S2)*(Wmax-We2);
        Wsl(k)=Wsl(S2);
        s(k)=Wsl(k)/We(k);
        Wrm(k)=(1-s(k))*We(k)*2/P*60/2/pi;
        Zs(k)=Lls*We(k)*i+Rs;
        Zr(k)=Rr/s(k)+Llr*We(k)*i;
        Zm(k)=Lm*We(k)*i;
        Vs(k)=Vs(S2);
        Is(k)=Vs(k)/(Zs(k)+(1/((1/Zr(k))+(1/Zm(k)))));
        Ir(k)=Is(k)*Zm/(Zm+Zr);
        Em(k)=abs(Vs(k)-Zs(k)*Is(k));
        T(k)=3/2*P*Rr*abs(Ir(k))^2/Wsl(k);
        Pout(k)=T(k)*(1-s(k))*We(k)*2/P;



    end
    

end


%% Capability curve

hold on;
grid on;
plot(Wrm,Wsl,'c','linewidth',2)
plot(Wrm,abs(Vs),'b','linewidth',2)
plot(Wrm,abs(Is),'r','linewidth',2)
plot(Wrm,T,'m','linewidth',2)
plot(Wrm,Pout/1000,'k','linewidth',2)
%plot(Wrm,Em,'b')
legend('Wsl[rad/s]','Vs[V]','Is[A]','Torque[Nm]','Power[kW]')
xlim([0 16000]);
xlabel('Wrm[rpm]');

axis auto



