clear all; clc; close all;

% Problem 2.

% Parameter
Power = 3.08e3;     % 3.08 kW
Ra = 0.26;          % Armature resistance [Ohm]
La = 1.7e-3;        % Armature inductance [Henry]
Irated = 24.9;      % Rated armature current [A]
wrated = 3000;      % Rated speed [r/min]
Vrated = 139;       % Rated armature voltage [V]
Jmotor = 0.00252;   % Inertia of the rotor of the motor [kgm^2]

%% sub-problem (1) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% constant calculation of DC machine
wrated = rpm2rps(wrated);               % r/min -> rad/sec
ke = (Vrated - Ra*Irated)/wrated;       % back EMF constant
kt = Power/(Irated*wrated);             % torque constant
K = 0.5 * (ke + kt);                    % Average value to use
% calculation of time constant
Ta = La / Ra;       % electric time constant
Tm = Jmotor*Ra / K^2;   % electromechanical time constant
% calculation zeta value for specifying response
zeta = 0.5*sqrt(Tm/Ta);
% function for telling response
judge(zeta);
% simulation
Vstep = 50;
sim('problem4_2_1_sim.mdl');
figure;
plot(time,wrm);axis([0.9 1.3 0 160]);
title('(1) Speed response of step input');
xlabel('time[s]');ylabel('Speed[rad/s]');
grid;
clear time; clear wrm;
% end of sub-problem (1) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% sub-problem (2) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% additional parameter
Jload = Jmotor; % Inertia of the load
B = 0.005;      % friction coefficient [N-m/(rad/s)]
steptime = 0;
Vstep = 50;
% simulation
sim('problem4_2_2_sim.mdl');

figure;
plot(time,wrm);
title('(2) Speed response of step input');
xlabel('time[s]');ylabel('Speed[r/min]');
grid;

figure;
plot(time,ia);
title('(2) Current response of step input');
xlabel('time[s]');ylabel('Current[A]');
grid;

figure;
plot(time,Te);
title('(2) Torque response of step input');
xlabel('time[s]');ylabel('Torque[N-m]');
grid;

figure;
plot(wrm,Te);
title('(2) Torque vs Speed');
xlabel('Speed[r/min]');ylabel('Torque[N-m]');
grid;

clear time; clear wrm;clear ia;clear Te;
% end of sub-problem (2) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% sub-problem (3) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% new parameter
Iref_step = 50;
J = Jmotor + Jload;
% gain
% [Kp,alpha] = solve('11*y = -(1.7e-3*0.005+0.00252*2*(0.26+x))/(1.7e-3*0.00252*2)','10*y^2 = (0.005*(0.26+x)+0.4078^2)/(1.7e-3*0.00252*2)')
Kp = 0.5724;
% simulation
sim('problem4_2_3_sim.mdl');

figure;
plot(time,wrm);
title('(3) Speed response of step input');
xlabel('time[s]');ylabel('Speed[r/min]');
grid;

figure;
plot(time,ia);
title('(3) Current response of step input');
xlabel('time[s]');ylabel('Current[A]');
grid;

figure;
plot(time,Te);
title('(3) Torque response of step input');
xlabel('time[s]');ylabel('Torque[N-m]');
grid;

figure;
plot(wrm,Te);
title('(3) Torque vs Speed');
xlabel('Speed[r/min]');ylabel('Torque[N-m]');
grid;

clear time; clear wrm;clear ia;clear Te;
% end of sub-problem (3) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% sub-problem (4) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% gain
Kp = 50;
% simulation
sim('problem4_2_3_sim.mdl');

figure;
plot(time,wrm);
title('(4) Speed response of step input');
xlabel('time[s]');ylabel('Speed[r/min]');
grid;

figure;
plot(time,ia);
title('(4) Current response of step input');
xlabel('time[s]');ylabel('Current[A]');
grid;

figure;
plot(time,Te);
title('(4) Torque response of step input');
xlabel('time[s]');ylabel('Torque[N-m]');
grid;

figure;
plot(wrm,Te);
title('(4) Torque vs Speed');
xlabel('Speed[r/min]');ylabel('Torque[N-m]');
grid;

clear time; clear wrm;clear ia;clear Te;
% end of sub-problem (4) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% sub-problem (5) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% gain
Kp = 50;
% simulation
sim('problem4_2_5_sim.mdl');

figure;
plot(time,wrm);
title('(5) Speed response of step input');
xlabel('time[s]');ylabel('Speed[r/min]');
grid;

figure;
plot(time,ia);
title('(5) Current response of step input');
xlabel('time[s]');ylabel('Current[A]');
grid;

figure;
plot(time,Te);
title('(5) Torque response of step input');
xlabel('time[s]');ylabel('Torque[N-m]');
grid;

figure;
plot(wrm,Te);
title('(5) Torque vs Speed');
xlabel('Speed[r/min]');ylabel('Torque[N-m]');
grid;

clear time; clear wrm;clear ia;clear Te;
% end of sub-problem (5) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% sub-problem (6) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% gain
Kp = 50;
% simulation
sim('problem4_2_6_sim.mdl');
figure;
plot(time,wrm);
title('(6) Speed response of step input');
xlabel('time[s]');ylabel('Speed[r/min]');
grid;

figure;
plot(time,ia);
title('(6) Current response of step input');
xlabel('time[s]');ylabel('Current[A]');
grid;

figure;
plot(time,Te);
title('(6) Torque response of step input');
xlabel('time[s]');ylabel('Torque[N-m]');
grid;

figure;
plot(wrm,Te);
title('(6) Torque vs Speed');
xlabel('Speed[r/min]');ylabel('Torque[N-m]');
grid;

clear time; clear wrm;clear ia;clear Te;
% end of sub-problem (6) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% sub-problem (7) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% gain
Kp = 1;
Kp1 = 10;
Kp2 = 50;
% simulation
sim('problem4_2_7_sim.mdl');

figure;hold on
plot(time,wrm,'b');plot(time,wrm1,'r');plot(time,wrm2,'k');
title('(7) Speed response of step input');
xlabel('time[s]');ylabel('Speed[r/min]');
legend('Kp = 1','Kp = 10','Kp = 50');
grid;hold off

figure;hold on
plot(time,ia,'b');plot(time,ia1,'r');plot(time,ia2,'k');plot(time,ia_ref,'g');
title('(7) Current response of step input');
xlabel('time[s]');ylabel('Current[A]');
legend('Kp = 1','Kp = 10','Kp = 50','reference');
grid;hold off

figure;hold on
plot(time,ia);plot(time,ia_ref,'r');
title('(7) Current response of step input, Kp = 1');
xlabel('time[s]');ylabel('Current[A]');
grid;hold off

figure;hold on
plot(time,ia1);plot(time,ia_ref,'r');
title('(7) Current response of step input, Kp = 10');
xlabel('time[s]');ylabel('Current[A]');
grid;hold off

figure;hold on
plot(time,ia2);plot(time,ia_ref,'r');
title('(7) Current response of step input, Kp = 50');
xlabel('time[s]');ylabel('Current[A]');
grid;hold off

clear time;
clear wrm;clear wrm1;clear wrm2;
clear ia;clear ia1;clear ia2;clear ia_ref
% end of sub-problem (7) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%