clear all; clc; close all;


% Current regulator
wcc = 2*pi*200;     % Bandwidth of current regulato
Jload = 0.5;       % Inertia of load [kg.m^2]
Jmotor = 0.1;       % Inertia of rotor of electric machine [kg.m^2]
Ksh = 700;      % Stiffness of the shaft [N-m/rad]
J=Jload+Jmotor;
Jhat=J*.9;      % Inertia in the controller design is 90% of total inertia.

Bactive=0;              % Active damping term
acc_ff=0;               % Acceleration feedforward gain
vel_ff=0;               % velocity feedforward gain
Tlmag=0;                 %Magnitude of load torque in N-m
Wtl=0;                %Angular frequency of  load torque in rad/s
Kalp=0;             % Acceleration feedback
% Limitation
Kjerk = 2*pi*100;
Kacc = 2*pi*20;
Kvel = 2*pi*20;

%% sub-problem (1) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Time
Tjerk = 0.2;
Tacc = 0.8;
Tvelc = 0.3;
Time1 = Tjerk;
Time2 = Time1+Tacc;
Time3 = Time2+Tjerk;
Time4 = Time3+Tvelc;
Time5 = Time4+Tjerk;
Time6 = Time5+Tacc;
Time7 = Time6+Tjerk;

% Simulation
sim('problem4_7_1_sim.mdl');

% Plot
figure;
subplot(4,1,1);
plot(time,jerk_ref);
title('(1) Jerk reference');
axis([0 3 -1000 1000]);
xlabel('time [sec]');ylabel('Jerk [rad/sec^3]');
grid;

subplot(4,1,2);
plot(time,acc_ref);
title('(1) Acceleration reference');
axis([0 3 -200 200]);
xlabel('time [sec]');ylabel('Acceleration [rad/sec^2]');
grid;

subplot(4,1,3);
plot(time,vel_ref);
title('(1) Speed reference');
axis([0 3 -100 200]);
xlabel('time [sec]');ylabel('Speed [rad/sec]');
grid;

subplot(4,1,4);
plot(time,dist_ref);
title('(1) Position reference');
axis([0 3 0 200]);
xlabel('time [sec]');ylabel('Position [rad]');
grid;
% end of sub-problem (1) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% sub-problem (2) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Iamax=50;               % Maximum current of Motor
KK=2;                   % Actual torque constant
KKhat=2*.9;              % Torque constant in the controller
Wsc=2*pi*16;             % Bandwidth of speed control loop
Kpv=Jhat*Wsc/KKhat     
Kiv=Kpv*Wsc/5
Kav=1/Kpv
Kp=Wsc/9


% end of sub-problem (2) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% sub-problem (3) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% simulation
sim('problem4_7_3_sim.mdl');

% Plot
figure;
subplot(4,1,1);hold on
plot(time,jerk_ref,'r');plot(time,jrl,'b');
title('(3) Jerk');
axis([0 3 -1000 1000]);
xlabel('time [sec]');ylabel('Jerk [rad/sec^3]');
legend('Jerk reference','Jerk');
grid;hold off

subplot(4,1,2);hold on
plot(time,acc_ref,'r');plot(time,arl,'b');
title('(3) Acceleration');
axis([0 3 -200 200]);
xlabel('time [sec]');ylabel('Acceleration [rad/sec^2]');
legend('Acceleration reference','Acceleration');
grid;hold off

subplot(4,1,3);hold on
plot(time,vel_ref,'r');plot(time,wrl,'b');
title('(3) Speed');
axis([0 3 -100 200]);
xlabel('time [sec]');ylabel('Speed [rad/sec]');
legend('Speed reference','Speed');
grid;hold off

subplot(4,1,4);hold on
plot(time,dist_ref,'r');plot(time,dist,'b');
title('(3) Position');
axis([0 3 0 200]);
xlabel('time [sec]');ylabel('Position [rad]');
legend('Position reference','Position');
grid;hold off

figure;
plot(time,err);
title('time integral of the square of the position error');
grid;
% end of sub-problem (3) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% sub-problem (4) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% active damping
Bactive = 18.33;

% simulation
sim('problem4_7_3_sim.mdl');

% Plot
figure;
subplot(4,1,1);hold on
plot(time,jerk_ref,'r');plot(time,jrl,'b');
title('(4) Jerk');
axis([0 3 -1000 1000]);
xlabel('time [sec]');ylabel('Jerk [rad/sec^3]');
legend('Jerk reference','Jerk');
grid;hold off

subplot(4,1,2);hold on
plot(time,acc_ref,'r');plot(time,arl,'b');
title('(4) Acceleration');
axis([0 3 -200 200]);
xlabel('time [sec]');ylabel('Acceleration [rad/sec^2]');
legend('Acceleration reference','Acceleration');
grid;hold off

subplot(4,1,3);hold on
plot(time,vel_ref,'r');plot(time,wrl,'b');
title('(4) Speed');
axis([0 3 -100 200]);
xlabel('time [sec]');ylabel('Speed [rad/sec]');
legend('Speed reference','Speed');
grid;hold off

subplot(4,1,4);hold on
plot(time,dist_ref,'r');plot(time,dist,'b');
title('(4) Position');
axis([0 3 0 200]);
xlabel('time [sec]');ylabel('Position [rad]');
legend('Position reference','Position');
grid;hold off

figure;
plot(time,err);
title('(4) time integral of the square of the position error');
grid;
% end of sub-problem (4) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% sub-problem (5) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% simulation

acc_ff=Jhat;
vel_ff=1;
sim('problem4_7_3_sim.mdl');

% Plot
figure;
subplot(4,1,1);hold on
plot(time,jerk_ref,'r');plot(time,jrl,'b');
title('(5) Jerk');
axis([0 3 -1500 1500]);
xlabel('time [sec]');ylabel('Jerk [rad/sec^3]');
legend('Jerk reference','Jerk');
grid;hold off

subplot(4,1,2);hold on
plot(time,acc_ref,'r');plot(time,arl,'b');
title('(5) Acceleration');
axis([0 3 -200 200]);
xlabel('time [sec]');ylabel('Acceleration [rad/sec^2]');
legend('Acceleration reference','Acceleration');
grid;hold off

subplot(4,1,3);hold on
plot(time,vel_ref,'r');plot(time,wrl,'b');
title('(5) Speed');
axis([0 3 -100 200]);
xlabel('time [sec]');ylabel('Speed [rad/sec]');
legend('Speed reference','Speed');
grid;hold off

subplot(4,1,4);hold on
plot(time,dist_ref,'r');plot(time,dist,'b');
title('(5) Position');
axis([0 3 0 200]);
xlabel('time [sec]');ylabel('Position [rad]');
legend('Position reference','Position');
grid;hold off

figure;
plot(time,err);
title('(5) time integral of the square of the position error');
grid;
% end of sub-problem (5) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% sub-problem (6) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Tlmag=60;                 %Magnitude of load torque in N-m
Wtl=20*pi;                %Angular frequency of  load torque in rad/s
% simulation
sim('problem4_7_6_sim.mdl');

% Plot

figure;
subplot(4,1,1);hold on
plot(time,acc_ref,'r');plot(time,arl,'b');
title('(6) Acceleration');
axis([3 4 -200 200]);
xlabel('time [sec]');ylabel('Acceleration [rad/sec^2]');
legend('Acceleration reference','Acceleration');
grid;hold off

subplot(4,1,2);hold on
plot(time,vel_ref,'r');plot(time,wrl,'b');
title('(6) Speed');
axis([3 4 -5 5]);
xlabel('time [sec]');ylabel('Speed [rad/sec]');
legend('Speed reference','Speed');
grid;hold off

subplot(4,1,3);hold on
plot(time,dist_ref,'r');plot(time,dist,'b');
title('(6) Position');
axis([3 4 150 250]);
xlabel('time [sec]');ylabel('Position [rad]');
legend('Position reference','Position');
grid;hold off

subplot(4,1,4);hold on
plot(time,Te,'r');plot(time,Tl,'b');
title('(6) Torque');
axis([3 4 -120 120]);
xlabel('time [sec]');ylabel('Torque [N]');
legend('Torque','Load Torque');
grid;hold off
% end of sub-problem (6) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% sub-problem (7) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Kalp = 0.9*Jhat;

% simulation
sim('problem4_7_6_sim.mdl');

% Plot

figure;
subplot(4,1,1);hold on
plot(time,acc_ref,'r');plot(time,arl,'b');
title('(7) Acceleration');
axis([3 4 -200 200]);
xlabel('time [sec]');ylabel('Acceleration [rad/sec^2]');
legend('Acceleration reference','Acceleration');
grid;hold off

subplot(4,1,2);hold on
plot(time,vel_ref,'r');plot(time,wrl,'b');
title('(7) Speed');
axis([3 4 -5 5]);
xlabel('time [sec]');ylabel('Speed [rad/sec]');
legend('Speed reference','Speed');
grid;hold off

subplot(4,1,3);hold on
plot(time,dist_ref,'r');plot(time,dist,'b');
title('(7) Position');
axis([3 4 150 250]);
xlabel('time [sec]');ylabel('Position [rad]');
legend('Position reference','Position');
grid;hold off

subplot(4,1,4);hold on
plot(time,Te,'r');plot(time,Tl,'b');
title('(7) Torque');
axis([3 4 -120 120]);
xlabel('time [sec]');ylabel('Torque [N]');
legend('Torque','Load Torque');
grid;hold off
% end of sub-problem (7) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%