clear all; clc; close all

% Problem 6

% parameter
M1 = 5;
M2 = 15;
Kcoup = 10^6;

%% sub-problem (1) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Simulation
sim('problem4_6_1_sim.mdl');

% Plot
figure;

subplot(3,1,1);
plot(time,acc_ref);
title('(1) Acceleration reference');
xlabel('time [s]');ylabel('Acceleration [rad/s^2]');
grid;

subplot(3,1,2);
plot(time,vel_ref);
title('(1) Speed reference');
xlabel('time [s]');ylabel('Speed [m/s]');
grid;

subplot(3,1,3);
plot(time,dist_ref);
title('(1) Position reference');
xlabel('time [s]');ylabel('Position [m]');
grid;
% end of sub-problem (1) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% sub-problem (3) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Kp = 1000*pi;
M_hat = 10;
Kdecoup = -1e8;
Bactive = 20000;

sim('problem4_6_3_sim.mdl');
% Plot
figure;hold on
plot(time,dist_ref-dist1,'r');
plot(time,dist_ref-dist2,'b');
title('(3) Position error with decoupling and active damping');
xlabel('time [s]');ylabel('Position [m]')
legend('S_x_1 error','S_x_2 error');
grid;hold off

figure;hold on
plot(time,dist1-dist2,'r');
title('(3) Position error between S_x_1 and S_x_2 ');
xlabel('time [s]');ylabel('Position [m]')
legend('With active damping and decouping');
grid;hold off

sim('problem4_6_3no_sim.mdl');
% Plot
figure;hold on
plot(time,dist_ref-dist1,'r');
plot(time,dist_ref-dist2,'b');
title('(3) Position error without any controller except P controller');
legend('S_x_1 error','S_x_2 error');
grid;hold off

figure;hold on
plot(time,dist1-dist2,'r');
title('(3) Position error between S_x_1 and S_x_2 ');
xlabel('time [s]');ylabel('Position [m]')
legend('No active damping and decouping');
grid;hold off
% end of sub-problem (3) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% sub-problem (4) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
beta = -150*2*pi;

l1 = -3*beta;
l2 = 3*beta^2;
l3 = beta^3*M_hat;

sim('problem4_6_4_sim.mdl');
% Plot
figure;hold on
plot(time,vel1,'r');
plot(time,est_vel1,'b');
title('(4) Velocity');
xlabel('time [s]');ylabel('Velocity [m/s]')
legend('V_x_1^*','V_x_1_e_s_t');
grid;hold off

figure;hold on
plot(time,vel2,'r');
plot(time,est_vel2,'b');
title('(4) Velocity');
xlabel('time [s]');ylabel('Velocity [m/s]')
legend('V_x_2^*','V_x_2_e_s_t');
grid;hold off

figure;hold on
plot(time,dist_ref-dist1,'r');
plot(time,dist_ref-dist2,'b');
title('(4) Position error with controller based on observer');
legend('S_x_1 error','S_x_2 error');
xlabel('time [s]');ylabel('Position [m]')
grid;hold off

figure;hold on
plot(time,dist1-dist2,'r');
title('(4) Position error between S_x_1 and S_x_2  based on observer');
xlabel('time [s]');ylabel('Position [m]')
legend('Active damping and decouping with observed speed');
grid;hold off


% end of sub-problem (4) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%