clear all
format short eng

%% Ķ

p=6;
Lam_f=0.2595;
Rs=0.109;
Ld=3.6e-3;
Lq=4.5e-3;

Vmax=170;
Imax=60;

%% ӵ  ְӵ 

id_rated=(Lam_f-sqrt(Lam_f^2+8*(Lq-Ld)^2*Imax^2))/(4*(Lq-Ld));
iq_rated=sqrt(Imax^2-id_rated^2);
wb=Vmax/sqrt((Lq*iq_rated)^2+(Ld*id_rated+Lam_f)^2);
w_max=Vmax/(Lam_f-Ld*Imax);

%% Operating Point 

resol=1000;
Wr=[linspace(-w_max,w_max,resol/2) linspace(w_max,-w_max,resol/2)];
id=zeros(1,resol);
iq=zeros(1,resol);

for i=1:resol/2
    if abs(Wr(i))<wb
        id(i)=id_rated;
        iq(i)=iq_rated;
    else
        id(i)=(-Lam_f*Ld*Wr(i)^2+sqrt((Lam_f*Ld*Wr(i)^2)^2-Wr(i)^2*(Ld^2-Lq^2)*(Wr(i)^2*((Lq*Imax)^2+Lam_f^2)-Vmax^2)))/(Wr(i)^2*(Ld^2-Lq^2));
        iq(i)=sqrt(Imax^2-id(i)^2);
    end
end

for i=resol/2+1:resol
    if abs(Wr(i))<wb
        id(i)=id_rated;
        iq(i)=-iq_rated;
    else
        id(i)=(-Lam_f*Ld*Wr(i)^2+sqrt((Lam_f*Ld*Wr(i)^2)^2-Wr(i)^2*(Ld^2-Lq^2)*(Wr(i)^2*((Lq*Imax)^2+Lam_f^2)-Vmax^2)))/(Wr(i)^2*(Ld^2-Lq^2));
        iq(i)=-sqrt(Imax^2-id(i)^2);
    end
end

P=3/2*Wr.*((Ld-Lq)*id.*iq+Lam_f*iq);
Te=P./(Wr*2/p);

%% Plot

plot(Wr*2/p*60/2/pi,Te,'linewidth',3);
xlabel('Speed [r/min]');
ylabel('Torque [N\cdotm]');
title('Four-Quadrant Capability Curve');
grid on;








