clear all;
clc;

V_LL_rated_rms = 208;
I_rated_rms = 11.8;
I_rated = I_rated_rms*sqrt(2);
I_max = I_rated*3;
V_max = V_LL_rated_rms*sqrt(2)/sqrt(3);

P_rated = 5*746;
Pole = 4;
PP = Pole/2;
rpm2rad= 2*pi/60;

Rs = 0.423;
Ls= 4.76e-3;
LamPM = 0.422;

J = 0.03;

w_base = V_max/sqrt(LamPM^2+(Ls*I_max)^2);
w_base_rpm = w_base*60/(2*pi);

a = Ls^2*I_max^2 + LamPM^2;
b = 2*Rs*LamPM*I_max;
c = Rs^2*LamPM^2/(Ls^2) - V_max^2;

w_base_real = (-b + sqrt(b^2- 4*a*c))/(2*a);
w_base_real_rpm = w_base_real*60/(2*pi);

w_max = V_max/(LamPM-Ls*I_max);
w_max_rpm = w_max*60/(2*pi);

w_max_real = sqrt((V_max^2 - Rs^2*LamPM^2/Ls^2))/(LamPM - Ls*I_max);
w_max_real_rpm = w_max_real*60/(2*pi);

Iqse_max = I_rated;
Idse_max = -sqrt(I_max^2-I_rated^2);

w_max2 = V_max/sqrt((LamPM + Ls*Idse_max)^2 + Ls^2*Iqse_max^2);
w_max2_rpm = w_max2*60/(2*pi);

Vdse = - w_max2*Ls*Iqse_max;
Vqse = w_max2*Ls*Idse_max + w_max2*LamPM;

Theta_v = atan2(Vqse, Vdse);
Theta_i = atan2(Iqse_max, Idse_max);

pf = cos(Theta_v-Theta_i);

a2 = (LamPM + Ls*Idse_max)^2 + Ls^2*Iqse_max^2;
b2 = 2*Ls*Iqse_max*Rs*LamPM/Ls;
c2 = Rs^2*LamPM^2/Ls^2 - V_max^2;

w_max2_real = (-b2 + sqrt(b2^2- 4*a2*c2))/(2*a2);
w_max2_real_rpm = w_max2_real*60/(2*pi);

Vdse_real =  Rs*Idse_max - w_max2_real*Ls*Iqse_max;
Vqse_real =  Rs*Iqse_max + w_max2_real*Ls*Idse_max + w_max2_real*LamPM;

Theta_v2 = atan2(Vqse_real, Vdse_real);
pf2 = cos(Theta_v2-Theta_i);
