clear all;
clc;

Pole = 4;
PP = Pole/2;

Rs = 0.4;
Llr = 2e-3;
Lls = Llr;
Lm = 70e-3;
Lr = Lm+Llr;
Ls = Lm+Lls;
Rr = 0.8;

Lambda_dr = 0.4;
Lambda_qr = 0;
wrm_rpm = 1200;
wrm_rad = wrm_rpm*2*pi/60;
wr = wrm_rad * PP;
Te = 20;

idse = Lambda_dr/Lm;
iqse = Te/(1.5*PP*Lm/Lr*Lambda_dr);
iqre = -Lm/Lr*iqse;

wsl = -Rr*iqre/Lambda_dr;
we = wr + wsl;

idre = 1/Lr*(Lambda_dr - Lm*idse);

Lambda_ds = Ls*idse + Lm*idre;
Lambda_qs = Ls*iqse + Lm*iqre;

Vdse = Rs*idse - we*Lambda_qs;
Vqse = Rs*iqse + we*Lambda_ds;

Pin = 1.5*(Vdse*idse + Vqse*iqse);

Vc = pi/2*sqrt(Vdse^2 + Vqse^2);

R_source = 0.5;
L_source = 2e-3;

idc = Pin/Vc;
Vd = Vc + R_source*idc;