clear all;
clc;


t=linspace(0,.2,1000);
Rr=0.55;
Lr=.0608;
idre0=0.413/Lr;
B=0.1;
J=.4;
Wr0=333.83;
Wr=Wr0*exp(-B/J.*t);
idre=idre0*exp(-Rr/Lr.*t);
Lamdre=idre*Lr;
Vdse=2.37*exp(-Rr/Lr.*t);
Vqse=.401*Wr.*exp(-Rr/Lr.*t);
Thetae=Wr.*t;

Vdss=cos(Thetae).*Vdse-sin(Thetae).*Vqse;
Vqss=sin(Thetae).*Vdse+cos(Thetae).*Vqse;
Vas=Vdss;
Vbs=(sqrt(3)*Vqss-Vdss)/2;
Vab=Vas-Vbs;

figure(1)
hold on;
subplot(3,1,1), plot(t, Wr, 'LineWidth', 1.5)
grid on;
ylabel('Angular speed [rad/s]')
xlabel('Time [s]')
legend('W_{r} [rad/s]')
subplot(3,1,2), plot(t, idre, 'LineWidth', 1.5)
grid on;
ylabel('D axis rotor current in synch. ref. frame [A]')
xlabel('Time [s]')
legend('i_{dr}^e [rad/s]')
hold off;
subplot(3,1,3), plot(t, Lamdre, 'LineWidth', 1.5)
grid on;
ylabel('D axis rotor flux in synch. ref. frame [V-s]')
xlabel('Time [s]')
legend('Lam_{dr}^e [V-s]')
hold off;

figure(2)
hold on;
subplot(2,1,1), plot(t, Vdse, 'LineWidth', 1.5)
grid on;
ylabel('D axis voltage at synch. ref. frame [V]')
xlabel('Time [s]')
legend('V_{ds}^e [V]')
subplot(2,1,2), plot(t, Vqse, 'LineWidth', 1.5)
grid on;
ylabel('Q axis voltage at synch. ref. frame [V]')
xlabel('Time [s]')
legend('V_{qs}^e [V]')
hold off;

figure(3)
hold on;
subplot(3,1,1), plot(t, Vas, 'LineWidth', 1.5)
grid on;
ylabel('Voltage [V]')
xlabel('Time [s]')
legend('V_{as} [V]')
subplot(3,1,2), plot(t, Vbs, 'LineWidth', 1.5)
grid on;
ylabel('Voltage [V]')
xlabel('Time [s]')
legend('V_{bs} [V]')
subplot(3,1,3), plot(t, Vab, 'LineWidth', 1.5)
grid on;
ylabel('Voltage [V]')
xlabel('Time [s]')
legend('V_{ab} [V]')
axis([0 0.2 -300 300])
hold off;


