clear all;

% parameter settings

% IPMSM


P=4;


Rs=0.232;
Ld=43e-3;
Lq=3.5e-3;
J=0.026;
B=0;



% operation condition
Ld_hat=1*Ld;
Lq_hat=1*Lq;
Rs_hat=Rs;
Wcc=2*pi*500;
% Gain for IPM
Kpcd=Ld_hat*Wcc;
Kicd=Rs_hat*Wcc;
Kacd=1/Kpcd;
Kpcq=Lq_hat*Wcc;
Kicq=Rs_hat*Wcc;
Kacq=1/Kpcq;

Vdc=300;
% Torque ref
Step_time1 = 0.1;
Step_time2 = 0.3;
Step_time3 = 0.5;

LoadTorque1 = 20;
LoadTorque2 = -20;
LoadTorque3 = 5;
%%
sim('SynRm_with_Vector_CC.mdl',0.5)

figure(1);
subplot(2,1,1);plot(t,Te_ref,'r',t,Te,'--b','LineWidth',2); grid on; xlabel('time[sec]');ylabel('Torque[N-m]');legend('Te_{ref}','Te')
subplot(2,1,2);plot(t,Wrpm,'LineWidth',2); grid on; xlabel('time[sec]');ylabel('Speed[r/min]');legend('Wrpm')
figure(2);
subplot(2,1,1);plot(t,Idqsr_ref(:,1),'r',t,Idqsr(:,1),'--b','LineWidth',2); grid on;xlabel('time[sec]');ylabel('Current[A]');legend('I_{ds}^{r}ref','I_{ds}^{r}');
subplot(2,1,2);plot(t,Idqsr_ref(:,2),'r',t,Idqsr(:,2),'--b','LineWidth',2); grid on;xlabel('time[sec]');ylabel('Current[A]');legend('I_{qs}^{r}ref','I_{qs}^{r}');
figure(3);
plot(t,Iabcs(:,1),'LineWidth',2); grid on; xlabel('time[sec]');ylabel('Current[r/min]');legend('A phase current')
% axis([0.09 0.14 -2 18])






