

%% parameters and Conditions
clear all;
clc;
P_rated=3730;
Wrated=1739;
V_l2l_rated=220;
Va_rated=V_l2l_rated/sqrt(3);
Ia_rated=12;
Rs=0.55;
Rr=0.36;
Lm=59e-3;
Lls=1.8e-3;
Llr=1.8e-3;
Ls=Lm+Lls;
Lr=Lm+Llr;
P=4;
J=0.04;
B=0;
Vdc=300;
LAM_dre_ref=0.4;
Loadtorque1 = 20;
Loadtorque2 = -20;
Loadtorque3 = 20;

Step_time1 = 0.5;
Step_time2 = 0.7;
Step_time3 = 0.9;
Step_time4 = 1.5;


Tnoise = 100e-6;

Ioffset = Ia_rated*0.01;
Inoise = (Ia_rated*0.04)^2*Tnoise;
Woffset = 0.01*2*pi/60;
Wnoise = (1*2*pi/60)^2 * Tnoise;

%% operating condition 14-(2)

Lls_hat = Lls;
Llr_hat = Llr;
Lm_hat=Lm;
Lr_hat=Llr_hat+Lm_hat;
Ls_hat=Lls_hat+Lm_hat;
Rs_hat=Rs;
Rr_hat=Rr;
sigma=1-(Lm_hat^2/Ls_hat/Lr_hat);

% Complex Current Control
Wcc=2*pi*500;
Rv=10*Rs_hat;
Kp=sigma*Ls_hat*Wcc;

Ka=1/Kp;

Ki=(Rs_hat+Rv+Rr_hat*(Lm_hat/Lr_hat)^2)*Wcc;
%% operating condition 14-(3),(4)
Lls_hat = 1.2*Lls;
Llr_hat = 1.2*Llr;
Lm_hat=1.1*Lm;
Lr_hat=Llr_hat+Lm_hat;
Ls_hat=Lls_hat+Lm_hat;
Rs_hat=0.8*Rs;
% Rs_hat=1.2*Rs;
Rr_hat=0.7*Rr;
% Rr_hat=1.3*Rr;
sigma=1-(Lm_hat^2/Ls_hat/Lr_hat);
% Complex Current Control
Wcc=2*pi*500;
Rv=10*Rs_hat;
Kp=sigma*Ls_hat*Wcc;

Ka=1/Kp;

Ki=(Rs_hat+Rv+Rr_hat*(Lm_hat/Lr_hat)^2)*Wcc;




%% Graph 14-(2)

sim('P15_Complex_vector_CC.mdl',1.5);

figure(1);
subplot(2,1,1);plot(t,Te_ref,'r',t,Te,'--b','LineWidth',2); grid on; xlabel('time[sec]');ylabel('Torque[N-m]');legend('Te_{ref}','Te')
subplot(2,1,2);plot(t,Wrpm,'LineWidth',2); grid on; xlabel('time[sec]');ylabel('Speed[r/min]');legend('Wrpm')
figure(2);
subplot(2,1,1);plot(t,Idqse_ref(:,1),'r',t,Idqse(:,1),'--b','LineWidth',2); grid on;xlabel('time[sec]');ylabel('Current[A]');legend('I_{ds}^{e}ref','I_{de}^{r}');
subplot(2,1,2);plot(t,Idqse_ref(:,2),'r',t,Idqse(:,2),'--b','LineWidth',2); grid on;xlabel('time[sec]');ylabel('Current[A]');legend('I_{qs}^{e}ref','I_{qe}^{r}');
figure(3);
plot(t,LAMdre_ref,'r',t,LAMdqr(:,1),'--b',t,LAMdqr(:,2),'k','LineWidth',2); grid on;xlabel('time[sec]');ylabel('Flux linkage [Wb-t]');legend('LAM_{dr}^{e}ref','LAM_{dr}^{e}','LAM_{qr}^{e}');
% figure(4);
% plot(t,Theta_error);grid on;

%% Graph 14-(3)
sim('P15_Complex_vector_CC_3.mdl',1.5);

figure(1);
subplot(2,1,1);plot(t,Te_ref,'r',t,Te,'--b','LineWidth',2); grid on; xlabel('time[sec]');ylabel('Torque[N-m]');legend('Te_{ref}','Te')
subplot(2,1,2);plot(t,Wrpm,'LineWidth',2); grid on; xlabel('time[sec]');ylabel('Speed[r/min]');legend('Wrpm')
figure(2);
subplot(2,1,1);plot(t,Idqse_ref(:,1),'r',t,Idqse(:,1),'--b','LineWidth',2); grid on;xlabel('time[sec]');ylabel('Current[A]');legend('I_{ds}^{e}ref','I_{de}^{r}');
subplot(2,1,2);plot(t,Idqse_ref(:,2),'r',t,Idqse(:,2),'--b','LineWidth',2); grid on;xlabel('time[sec]');ylabel('Current[A]');legend('I_{qs}^{e}ref','I_{qe}^{r}');
figure(3);
plot(t,LAMdre_ref,'r',t,LAMdqr(:,1),'--b',t,LAMdqr(:,2),'k','LineWidth',2); grid on;xlabel('time[sec]');ylabel('Current[A]');legend('LAM_{dr}^{e}ref','LAM_{dr}^{e}','LAM_{qr}^{e}');
% figure(4);
% plot(t,Theta_error);grid on;
%% Graph 14-(4)
sim('P15_Complex_vector_CC_4.mdl',1.5);

figure(1);
subplot(2,1,1);plot(t,Te_ref,'r',t,Te,'--b','LineWidth',2); grid on; xlabel('time[sec]');ylabel('Torque[N-m]');legend('Te_{ref}','Te')
subplot(2,1,2);plot(t,Wrpm,'LineWidth',2); grid on; xlabel('time[sec]');ylabel('Speed[r/min]');legend('Wrpm')
figure(2);
subplot(2,1,1);plot(t,Idqse_ref(:,1),'r',t,Idqse(:,1),'--b','LineWidth',2); grid on;xlabel('time[sec]');ylabel('Current[A]');legend('I_{ds}^{e}ref','I_{de}^{r}');
subplot(2,1,2);plot(t,Idqse_ref(:,2),'r',t,Idqse(:,2),'--b','LineWidth',2); grid on;xlabel('time[sec]');ylabel('Current[A]');legend('I_{qs}^{e}ref','I_{qe}^{r}');
figure(3);
plot(t,LAMdre_ref,'r',t,LAMdqr(:,1),'--b',t,LAMdqr(:,2),'k','LineWidth',2); grid on;xlabel('time[sec]');ylabel('Flux linkage [Wb-t]');legend('LAM_{dr}^{e}ref','LAM_{dr}^{e}','LAM_{qr}^{e}');
% figure(4);
% plot(t,Theta_error);grid on;
